#ifndef _MB_H
#define _MB_H

#include "port.h"

#ifdef __cplusplus
PR_BEGIN_EXTERN_C
#endif

#include "mbport.h"
#include "mbproto.h"

typedef enum
{
    MB_RTU,                     /*!< RTU transmission mode. */
    MB_ASCII,                   /*!< ASCII transmission mode. */
    MB_TCP                      /*!< TCP mode. */
} eMBMode;

typedef enum
{
    MB_REG_READ,                /*!< Read register values and pass to protocol stack. */
    MB_REG_WRITE                /*!< Update register values. */
} eMBRegisterMode;

typedef enum
{
    MB_ENOERR,                  /*!< no error. ޴*/
    MB_ENOREG,                  /*!< illegal register address.ЧĴַ */
    MB_EINVAL,                  /*!< illegal argument.Ч */
    MB_EPORTERR,                /*!< porting layer error.ֲ */
    MB_ENORES,                  /*!< insufficient resources. Դ*/
    MB_EIO,                     /*!< I/O error.I/O */
    MB_EILLSTATE,               /*!< protocol stack in illegal state.Эջ״̬*/
    MB_ETIMEDOUT                /*!< timeout error occurred. ʱ*/
} eMBErrorCode;

eMBErrorCode    eMBInit( eMBMode eMode, UCHAR ucSlaveAddress,
                         UCHAR ucPort, ULONG ulBaudRate, eMBParity eParity );

eMBErrorCode    eMBTCPInit( USHORT usTCPPort );

eMBErrorCode    eMBClose( void );

eMBErrorCode    eMBEnable( void );

eMBErrorCode    eMBDisable( void );

eMBErrorCode    eMBPoll( void );

eMBErrorCode    eMBSetSlaveID( UCHAR ucSlaveID, BOOL xIsRunning,
                               UCHAR const *pucAdditional,
                               USHORT usAdditionalLen );

eMBErrorCode    eMBRegisterCB( UCHAR ucFunctionCode, 
                               pxMBFunctionHandler pxHandler );

/* ----------------------- Callback -----------------------------------------*/
eMBErrorCode    eMBRegInputCB( UCHAR * pucRegBuffer, USHORT usAddress,
                               USHORT usNRegs );

eMBErrorCode    eMBRegHoldingCB( UCHAR * pucRegBuffer, USHORT usAddress,
                                 USHORT usNRegs, eMBRegisterMode eMode );

eMBErrorCode    eMBRegCoilsCB( UCHAR * pucRegBuffer, USHORT usAddress,
                               USHORT usNCoils, eMBRegisterMode eMode );


eMBErrorCode    eMBRegDiscreteCB( UCHAR * pucRegBuffer, USHORT usAddress,
                                  USHORT usNDiscrete );

#ifdef __cplusplus
PR_END_EXTERN_C
#endif
#endif
