/* ----------------------- System includes ----------------------------------*/
#include "stdlib.h"
#include "string.h"

#include "COM3RS485.h"
/* ----------------------- Platform includes --------------------------------*/
#include "port.h"

/* ----------------------- Modbus includes ----------------------------------*/

#include "mb.h"
#include "mbconfig.h"
#include "mbframe.h"
#include "mbproto.h"
#include "mbfunc.h"

#include "mbport.h"
#if MB_RTU_ENABLED == 1
#include "mbrtu.h"
#endif
#if MB_ASCII_ENABLED == 1
#include "mbascii.h"
#endif
#if MB_TCP_ENABLED == 1
#include "mbtcp.h"
#endif

#ifndef MB_PORT_HAS_CLOSE
#define MB_PORT_HAS_CLOSE 0
#endif

/* ----------------------- Static variables ---------------------------------*/

static UCHAR    ucMBAddress;
static eMBMode  eMBCurrentMode;

static enum
{
    STATE_ENABLED,
    STATE_DISABLED,
    STATE_NOT_INITIALIZED
} eMBState = STATE_NOT_INITIALIZED;


/*eMBInit( )гʼĺָ롣ȡڲͬģʽӦΪȷģʽ*/
static peMBFrameSend    peMBFrameSendCur;/*modbusӻӦ*/ 
static pvMBFrameStart   pvMBFrameStartCur;/*ʹmodbusЭջ*/
static pvMBFrameStop    pvMBFrameStopCur;/*modbusЭջ*/
static peMBFrameReceive peMBFrameReceiveCur;/*modbusĽպ*/ 
static pvMBFrameClose   pvMBFrameCloseCur;/*modbusĹرպ*/ 

BOOL( *pxMBFrameCBByteReceived ) ( void );
BOOL( *pxMBFrameCBTransmitterEmpty ) ( void );
BOOL( *pxMBPortCBTimerExpired ) ( void );

BOOL( *pxMBFrameCBReceiveFSMCur ) ( void );
BOOL( *pxMBFrameCBTransmitFSMCur ) ( void );

/*xFuncHandlers[i]ǽṹ飬ŵǹԼӦıĽ*/
static xMBFunctionHandler xFuncHandlers[MB_FUNC_HANDLERS_MAX] = {
#if MB_FUNC_OTHER_REP_SLAVEID_ENABLED > 0
    {MB_FUNC_OTHER_REPORT_SLAVEID, eMBFuncReportSlaveID},
#endif
#if MB_FUNC_READ_INPUT_ENABLED > 0
    {MB_FUNC_READ_INPUT_REGISTER, eMBFuncReadInputRegister},
#endif
#if MB_FUNC_READ_HOLDING_ENABLED > 0
    {MB_FUNC_READ_HOLDING_REGISTER, eMBFuncReadHoldingRegister},
#endif
#if MB_FUNC_WRITE_MULTIPLE_HOLDING_ENABLED > 0
    {MB_FUNC_WRITE_MULTIPLE_REGISTERS, eMBFuncWriteMultipleHoldingRegister},
#endif
#if MB_FUNC_WRITE_HOLDING_ENABLED > 0
    {MB_FUNC_WRITE_REGISTER, eMBFuncWriteHoldingRegister},
#endif
#if MB_FUNC_READWRITE_HOLDING_ENABLED > 0
    {MB_FUNC_READWRITE_MULTIPLE_REGISTERS, eMBFuncReadWriteMultipleHoldingRegister},
#endif
#if MB_FUNC_READ_COILS_ENABLED > 0
    {MB_FUNC_READ_COILS, eMBFuncReadCoils},
#endif
#if MB_FUNC_WRITE_COIL_ENABLED > 0
    {MB_FUNC_WRITE_SINGLE_COIL, eMBFuncWriteCoil},
#endif
#if MB_FUNC_WRITE_MULTIPLE_COILS_ENABLED > 0
    {MB_FUNC_WRITE_MULTIPLE_COILS, eMBFuncWriteMultipleCoils},
#endif
#if MB_FUNC_READ_DISCRETE_INPUTS_ENABLED > 0
    {MB_FUNC_READ_DISCRETE_INPUTS, eMBFuncReadDiscreteInputs},
#endif
};

/* ----------------------- Start implementation -----------------------------*/
/*ܣ 
*1:ʵRTUģʽASCALLģʽЭջʼ; 
*2:ЭջĺָĸֵModbusЭջʹܺͽֹĵĽպӦ3.5Tʱжϻصڷͺͽжϻص; 
*3:eMBRTUInitRTUģʽ´ں3.5TʱĳʼûԼֲ; 
*4:ModbusЭջģʽeMBCurrentModeΪMB_RTUModbusЭջ״̬eMBStateΪSTATE_DISABLED; 
*/
//eMBInit(MB_RTU, 0x01, 0, 9600, MB_PAR_NONE);
//ucSlaveAddress ģַֻзģַ߹㲥ַ֡ܵõ
//ucPort ֵӲصģֲѡԸò
eMBErrorCode eMBInit( eMBMode eMode, UCHAR ucSlaveAddress, UCHAR ucPort, ULONG ulBaudRate, eMBParity eParity )
{
    //״̬ʼֵ
    eMBErrorCode    eStatus = MB_ENOERR;

    //֤ӻַ
    /*жǹ㲥ַǴӻַ*/
    if( ( ucSlaveAddress == MB_ADDRESS_BROADCAST ) || ( ucSlaveAddress < MB_ADDRESS_MIN ) || ( ucSlaveAddress > MB_ADDRESS_MAX ) )
    {
        eStatus = MB_EINVAL;//Ƿַ
    }
    else
    {
        ucMBAddress = ucSlaveAddress; /*ӻַĸֵ*/

        switch ( eMode )//ѡݴģʽʱѡҲֻܴһЭ鷽ʽ
        {
#if MB_RTU_ENABLED > 0//RTUʹ
        case MB_RTU:
            pvMBFrameStartCur       = eMBRTUStart;/*ʹmodbusЭջ*/
            pvMBFrameStopCur        = eMBRTUStop; /*modbusЭջ*/
            peMBFrameSendCur        = eMBRTUSend;/*modbusӻӦ*/
            peMBFrameReceiveCur     = eMBRTUReceive;/*modbusĽպ*/
            pvMBFrameCloseCur       = MB_PORT_HAS_CLOSE ? vMBPortClose : NULL;
            //״̬
            pxMBFrameCBByteReceived = xMBRTUReceiveFSM; /*ڽжյô˺*/  
            //״̬
            pxMBFrameCBTransmitterEmpty = xMBRTUTransmitFSM;/*ڷжյô˺*/  
            //ĵ
            pxMBPortCBTimerExpired  = xMBRTUTimerT35Expired; /*ʱжϺյôκɶʱж*/  
            //ʼRTU 
            eStatus = eMBRTUInit( ucMBAddress, ucPort, ulBaudRate, eParity );//ʼʱڣRTU
            break;
#endif
#if MB_ASCII_ENABLED > 0
        case MB_ASCII:
            pvMBFrameStartCur = eMBASCIIStart;
            pvMBFrameStopCur = eMBASCIIStop;
            peMBFrameSendCur = eMBASCIISend;
            peMBFrameReceiveCur = eMBASCIIReceive;
            pvMBFrameCloseCur = MB_PORT_HAS_CLOSE ? vMBPortClose : NULL;
            pxMBFrameCBByteReceived = xMBASCIIReceiveFSM;
            pxMBFrameCBTransmitterEmpty = xMBASCIITransmitFSM;
            pxMBPortCBTimerExpired = xMBASCIITimerT1SExpired;

            eStatus = eMBASCIIInit( ucMBAddress, ucPort, ulBaudRate, eParity );
            break;
#endif
        default:
            eStatus = MB_EINVAL;
        }

        if( eStatus == MB_ENOERR )
        {
            if( !xMBPortEventInit(  ) )//¼ʼ
            {
                /* port dependent event module initalization failed. */
                /*¼ģʼʧ*/
                eStatus = MB_EPORTERR;
            }
            else
            {
                 //趨ǰ״̬
                eMBCurrentMode = eMode;//趨RTUģʽ 
                eMBCurrentMode = eMBCurrentMode;
                eMBState = STATE_DISABLED;//modbusЭջʼ״̬,ڴ˳ʼΪֹ  
//                 RS485_Send_Data("dfgfdg",8);
            }
        }
    }
    return eStatus;
}

#if MB_TCP_ENABLED > 0

eMBErrorCode eMBTCPInit( USHORT ucTCPPort )
{
    eMBErrorCode    eStatus = MB_ENOERR;

    if( ( eStatus = eMBTCPDoInit( ucTCPPort ) ) != MB_ENOERR )
    {
        eMBState = STATE_DISABLED;
    }
    else if( !xMBPortEventInit(  ) )
    {
        /* Port dependent event module initalization failed. */
        eStatus = MB_EPORTERR;
    }
    else
    {
        pvMBFrameStartCur = eMBTCPStart;
        pvMBFrameStopCur = eMBTCPStop;
        peMBFrameReceiveCur = eMBTCPReceive;
        peMBFrameSendCur = eMBTCPSend;
        pvMBFrameCloseCur = MB_PORT_HAS_CLOSE ? vMBTCPPortClose : NULL;
        ucMBAddress = MB_TCP_PSEUDO_ADDRESS;
        eMBCurrentMode = MB_TCP;
        eMBState = STATE_DISABLED;
    }
    return eStatus;
}
#endif
////////////////////////////////////                     Ӧ
eMBErrorCode eMBRegisterCB( UCHAR ucFunctionCode, pxMBFunctionHandler pxHandler )//ModbusЭļĴص
{
    int             i;
// 		OS_CPU_SR cpu_sr=0;
    eMBErrorCode    eStatus;

    if( ( 0 < ucFunctionCode ) && ( ucFunctionCode <= 127 ) )
    {
        ENTER_CRITICAL_SECTION(  );
        if( pxHandler != NULL )
        {
            for( i = 0; i < MB_FUNC_HANDLERS_MAX; i++ )
            {
                if( ( xFuncHandlers[i].pxHandler == NULL ) || ( xFuncHandlers[i].pxHandler == pxHandler ) )
                {
                    xFuncHandlers[i].ucFunctionCode = ucFunctionCode;
                    xFuncHandlers[i].pxHandler = pxHandler;
                    break;
                }
            }
            eStatus = ( i != MB_FUNC_HANDLERS_MAX ) ? MB_ENOERR : MB_ENORES;
        }
        else
        {
            for( i = 0; i < MB_FUNC_HANDLERS_MAX; i++ )
            {
                if( xFuncHandlers[i].ucFunctionCode == ucFunctionCode )
                {
                    xFuncHandlers[i].ucFunctionCode = 0;
                    xFuncHandlers[i].pxHandler = NULL;
                    break;
                }
            }
            /* Remove can't fail. */
            eStatus = MB_ENOERR;
        }
        EXIT_CRITICAL_SECTION(  );
    }
    else
    {
        eStatus = MB_EINVAL;
    }
    return eStatus;
}


eMBErrorCode eMBClose( void )
{
    eMBErrorCode    eStatus = MB_ENOERR;

    if( eMBState == STATE_DISABLED )
    {
        if( pvMBFrameCloseCur != NULL )
        {
            pvMBFrameCloseCur(  );
        }
    }
    else
    {
        eStatus = MB_EILLSTATE;
    }
    return eStatus;
}

/* 
*1:ModbusЭջ״̬eMBStateΪSTATE_ENABLED; 
*2:pvMBFrameStartCur()Эջ 
*/
eMBErrorCode eMBEnable( void )
{
    eMBErrorCode    eStatus = MB_ENOERR;

    if( eMBState == STATE_DISABLED )//eMBStateeMBInitб趨ΪDISABLE
    {   
        /*Эջ*//* Activate the protocol stack. */
        pvMBFrameStartCur();  /*pvMBFrameStartCur = eMBRTUStart;eMBRTUStart*/
        eMBState = STATE_ENABLED;
//        RS485_Send_Data("54341312\n",8);
    }
    else
    {
        eStatus = MB_EILLSTATE;//Ƿ״̬
//         RS485_Send_Data("fdgfds\n",8);
    }
    return eStatus;
}

eMBErrorCode eMBDisable( void )
{
    eMBErrorCode    eStatus;

    if( eMBState == STATE_ENABLED )
    {
        pvMBFrameStopCur(  );
        eMBState = STATE_DISABLED;
        eStatus = MB_ENOERR;
    }
    else if( eMBState == STATE_DISABLED )
    {
        eStatus = MB_ENOERR;
    }
    else
    {
        eStatus = MB_EILLSTATE;
    }
    return eStatus;
}

/*: 
*1:Эջ״̬ǷʹܣeMBStateֵΪSTATE_NOT_INITIALIZEDeMBInit()бֵΪSTATE_DISABLED,eMBEnableбֵΪSTATE_ENABLE; 
*2:ѯEV_FRAME_RECEIVED¼EV_FRAME_RECEIVED¼һ֡ݣϱEV_EXECUTE¼һ֡ģӦ()һ֡ݸ; 
*/
eMBErrorCode eMBPoll( void )//
{
    static UCHAR        *ucMBFrame;//պͷͱݻ 
    static UCHAR        ucRcvAddress; //modbusӻַ 
    static UCHAR        ucFunctionCode;//
    static USHORT       usLength;//ĳ  
    static eMBException eException;//Ӧö 

    int             i;
    eMBErrorCode    eStatus = MB_ENOERR; //modbusЭջ  
    eMBEventType    eEvent; //¼־ö

    if( eMBState != STATE_ENABLED ) //ЭջǷʹ
    {
        return MB_EILLSTATE;//ЭջδʹܣЭջЧ
    }

     //ѯ¼Ƿ
    if( xMBPortEventGet( &eEvent ) == TRUE )//ѯĸ¼
    {
        switch ( eEvent )//¼ö
        {
            case EV_READY://RS485_Send_Data("EV_READY\n",8);//׼
                break;

            case EV_FRAME_RECEIVED:// RS485_Send_Data("EV_FRAME_RECEIVED\n",8);/*յһ֡ݣ¼*/
                eStatus = peMBFrameReceiveCur( &ucRcvAddress, &ucMBFrame, &usLength );//ѯս浽ucMBFrameִеeMBRTUReceive( UCHAR * pucRcvAddress, UCHAR ** pucFrame, USHORT * pusLength )
                if( eStatus == MB_ENOERR )/*ĳȺCRCУȷ*/ 
                {
                    /* Check if the frame is for us. If not ignore the frame. */
                    /*жϽյıǷɽܣǣ*/
                    if( ( ucRcvAddress == ucMBAddress ) || ( ucRcvAddress == MB_ADDRESS_BROADCAST ) )//жϵַǴӻַǹ㲥ַ
                    {
                        ( void )xMBPortEventPost( EV_EXECUTE );//޸¼־ΪEV_EXECUTEִ¼ 
                    }
                }
                
                break;

            case EV_EXECUTE://RS485_Send_Data("EV_EXECUTE\n",8);//ԽյıĽд¼
                ucFunctionCode = ucMBFrame[MB_PDU_FUNC_OFF];//ȡPDUеһֽڣΪ
                eException = MB_EX_ILLEGAL_FUNCTION;//ֵΪЧĹ 
                for( i = 0; i < MB_FUNC_HANDLERS_MAX; i++ )
                {
                    /* No more function handlers registered. Abort. */
                    if( xFuncHandlers[i].ucFunctionCode == 0 )
                    {
                        break;
                    }
                    else if( xFuncHandlers[i].ucFunctionCode == ucFunctionCode )/*ݱеĹ룬*/  
                    {
                        eException = xFuncHandlers[i].pxHandler( ucMBFrame, &usLength );/*ԽյıĽн*/  
                        break;
                    }
                }

                /* If the request was not sent to the broadcast address we
                 * return a reply. */
                if( ucRcvAddress != MB_ADDRESS_BROADCAST )
                {
                    if( eException != MB_EX_NONE )/*յıд*/  
                    {
                        /* An exception occured. Build an error frame. */
                        usLength = 0;/*ӦݵֽΪӻַ*/  
                        ucMBFrame[usLength++] = ( UCHAR )( ucFunctionCode | MB_FUNC_ERROR );/*Ӧ֡ĵڶֽڣλ1*/  
                        ucMBFrame[usLength++] = eException;/*Ӧ֡ĵֽΪʶ*/  
                    }

                    eStatus = peMBFrameSendCur( ucMBAddress, ucMBFrame, usLength );/*modbusӻӦ,Ӧ*/  
                }
                break;

            case EV_FRAME_SENT://RS485_Send_Data("EV_FRAME_SENT\n",8);//֡
                break;
        }
    }
    return MB_ENOERR;
}
