/* ----------------------- System includes --------------------------------*/
#include <port.h>

/* ----------------------- Modbus includes ----------------------------------*/
#include "mb.h"
#include "mbport.h"


/* ----------------------- Modbus includes ----------------------------------*/
#include "mb.h"
#include "mbport.h"

/* ----------------------- Defines ------------------------------------------*/
#define REG_INPUT_START         1
#define REG_INPUT_NREGS         20
#define REG_HOLDING_START 	    1
#define REG_HOLDING_NREGS 	    10
/* ----------------------- Static variables ---------------------------------*/
static USHORT   usRegInputStart = REG_INPUT_START;
static USHORT   usRegInputBuf[REG_INPUT_NREGS];
static USHORT   usRegHoldingStart = REG_HOLDING_START;
static USHORT   usRegHoldingBuf[REG_HOLDING_NREGS];
/* ----------------------- Variables ----------------------------------------*/
int             VIC_Temp;

/* ----------------------- Start implementation -----------------------------*/
void EnterCriticalSection(  )
{
	__ASM volatile("cpsid i");
}

void ExitCriticalSection(  )
{
	__ASM volatile("cpsie i");
}

/****************************************************************************
* 	  ƣeMBRegInputCB   Ĵ
*     ܣȡĴӦ 04 eMBFuncReadInputRegister
* ڲpucRegBuffer: ݻӦ   
*						usAddress: Ĵַ
*						usNRegs: ҪȡļĴ
* ڲ
* ע	  ⣺λ ֡ʽ: SlaveAddr(1 Byte)+FuncCode(1 Byte)
*								+StartAddrHiByte(1 Byte)+StartAddrLoByte(1 Byte)
*								+LenAddrHiByte(1 Byte)+LenAddrLoByte(1 Byte)+
*								+CRCAddrHiByte(1 Byte)+CRCAddrLoByte(1 Byte)
*							3 
****************************************************************************/
eMBErrorCode
eMBRegInputCB( UCHAR * pucRegBuffer, USHORT usAddress, USHORT usNRegs )
{
    eMBErrorCode    eStatus = MB_ENOERR;
    int             iRegIndex;

    if( ( usAddress >= REG_INPUT_START )
        && ( usAddress + usNRegs <= REG_INPUT_START + REG_INPUT_NREGS ) )
    {
        iRegIndex = ( int )( usAddress - usRegInputStart );
        while( usNRegs > 0 )
        {
            *pucRegBuffer++ = ( UCHAR )( usRegInputBuf[iRegIndex] >> 8 );
            *pucRegBuffer++ = ( UCHAR )( usRegInputBuf[iRegIndex] & 0xFF );
            iRegIndex++;
            usNRegs--;
        }
    }
    else
    {
        eStatus = MB_ENOREG;
    }

    return eStatus;
}

/****************************************************************************
* 	  ƣeMBRegHoldingCB  ּĴ
*     ܣӦУ06 дּĴ eMBFuncWriteHoldingRegister 
*													16 дּĴ eMBFuncWriteMultipleHoldingRegister
*													03 ּĴ eMBFuncReadHoldingRegister
*													23 дּĴ eMBFuncReadWriteMultipleHoldingRegister
* ڲpucRegBuffer: ݻӦ   
*						usAddress: Ĵַ
*						usNRegs: ҪдļĴ
*						eMode: 
* ڲ
* ע	  ⣺4 
****************************************************************************/
eMBErrorCode
eMBRegHoldingCB( UCHAR * pucRegBuffer, USHORT usAddress, USHORT usNRegs, eMBRegisterMode eMode )
{
	eMBErrorCode    eStatus = MB_ENOERR;
	int             iRegIndex;


	if((usAddress >= REG_HOLDING_START)&&\
		((usAddress+usNRegs) <= (REG_HOLDING_START + REG_HOLDING_NREGS)))
	{
		iRegIndex = (int)(usAddress - usRegHoldingStart);
		switch(eMode)
		{                                       
			case MB_REG_READ:// MB_REG_READ = 0
        while(usNRegs > 0)
				{
					*pucRegBuffer++ = (u8)(usRegHoldingBuf[iRegIndex] >> 8);            
					*pucRegBuffer++ = (u8)(usRegHoldingBuf[iRegIndex] & 0xFF); 
          iRegIndex++;
          usNRegs--;					
				}                            
        break;
			case MB_REG_WRITE://д MB_REG_WRITE = 0
				while(usNRegs > 0)
				{         
					usRegHoldingBuf[iRegIndex] = *pucRegBuffer++ << 8;
          usRegHoldingBuf[iRegIndex] |= *pucRegBuffer++;
          iRegIndex++;
          usNRegs--;
        }				
			}
	}
	else//
	{
		eStatus = MB_ENOREG;
	}	
	
	return eStatus;
}

/****************************************************************************
* 	  ƣeMBRegCoilsCB  Ȧ
*     ܣӦУ01 Ȧ eMBFuncReadCoils
*													05 дȦ eMBFuncWriteCoil
*													15 дȦ eMBFuncWriteMultipleCoils
* ڲpucRegBuffer: ݻӦ   
*						usAddress: Ȧַ
*						usNCoils: ҪдȦ
*						eMode: 
* ڲ
* ע	  ⣺̵ 
*						0 
****************************************************************************/
eMBErrorCode
eMBRegCoilsCB( UCHAR * pucRegBuffer, USHORT usAddress, USHORT usNCoils, eMBRegisterMode eMode )
{
	eMBErrorCode    eStatus = MB_ENOERR;
	int             iRegIndex;


	if((usAddress >= REG_HOLDING_START)&&\
		((usAddress+usNCoils) <= (REG_HOLDING_START + REG_HOLDING_NREGS)))
	{
		iRegIndex = (int)(usAddress - usRegHoldingStart);
		switch(eMode)
		{                                       
			case MB_REG_READ:// MB_REG_READ = 0
                while(usNCoils > 0)
				{
 					*pucRegBuffer++ = (u8)(usRegHoldingBuf[iRegIndex] >> 8);            
 					*pucRegBuffer++ = (u8)(usRegHoldingBuf[iRegIndex] & 0xFF); 
                    iRegIndex++;
                    usNCoils--;					
				}                            
            break;
			case MB_REG_WRITE://д
				while(usNCoils > 0)
				{         
 					usRegHoldingBuf[iRegIndex] = *pucRegBuffer++ << 8;
                    usRegHoldingBuf[iRegIndex] |= *pucRegBuffer++;
                    iRegIndex++;
                    usNCoils--;
                 }	
                break;                
			}
	}
	else//
	{
		eStatus = MB_ENOREG;
	}	
	
	return eStatus;
}
/****************************************************************************
* 	  ƣeMBRegDiscreteCB 
*     ܣȡɢĴӦУ02 ɢĴ eMBFuncReadDiscreteInputs
* ڲpucRegBuffer: ݻӦ   
*						usAddress: Ĵַ
*						usNDiscrete: ҪȡļĴ
* ڲ
* ע	  ⣺1 
****************************************************************************/
eMBErrorCode
eMBRegDiscreteCB( UCHAR * pucRegBuffer, USHORT usAddress, USHORT usNDiscrete )
{
    ( void )pucRegBuffer;
    ( void )usAddress;
    ( void )usNDiscrete;
    pucRegBuffer = pucRegBuffer;
    return MB_ENOREG;
}

